int counter = 0;
int i = 0;
int r, v, b;

/*****************************************/
//Timer0
//Prescaler 1:1; TMR0 Preload = 156; Actual Interrupt Time : 100 us

//Place/Copy this part in declaration section
void InitTimer0(){
  OPTION_REG   = 0x88;
  TMR0         = 156;
  INTCON       = 0xA0;
}

void interrupt()
{
  if(TMR0IF_bit)
  {
    TMR0IF_bit  = 0;
    TMR0        = 156;

    if(r <= counter)  PORTB.B5 = 1;
    else  PORTB.B5 = 0;
    if(v <= counter)  PORTB.B6 = 1;
    else  PORTB.B6 = 0;
    if(b <= counter)  PORTB.B7 = 1;
    else  PORTB.B7 = 0;
    
    if(counter >= 255)
    {
      counter = 0;              // reset counter
    }
    else
      counter++;                // increment counter
  }
}
/******************************************/

void couleur(int numeroCouleur)
{
    switch(numeroCouleur)
    {
    case 1 : //marron
        r =  128;
        v =  0;
        b =  0;
        break;
    case 2 : //rouge
        r =  255;
        v =  0;
        b =  0;
        break;
    case 3 : //orange
        r =  255;
        v =  128;
        b =  0;
        break;
    case 4 : //jaune
        r =  255;
        v =  255;
        b =  0;
        break;
    case 5 : //vert
        r =  0;
        v =  255;
        b =  0;
        break;
    case 6 : //bleu
        r =  0;
        v =  0;
        b =  255;
        break;
    case 7 : //violet
        r =  255;
        v =  0;
        b =  255;
        break;
    case 8 : //bleu ciel
        r =  0;
        v =  255;
        b =  255;
        break;
    case 9 : //gris
        r =  128;
        v =  128;
        b =  128;
        break;
    case 10 : //blanc
        r =  255;
        v =  255;
        b =  255;
        break;
    default : //"noir"
    case 0 :
        r =  0;
        v =  0;
        b =  0;
        break;
    }
}

void main()
{
  PORTB = 0 ;
  TRISB = 0 ;             // set PORTB as output
  
  InitTimer0();

  INTCON.GIE = 1;         // Global interrupt enable
  INTCON.T0IE = 1;        // Enable Timer0 overflow interrupt

  while(1)
  {                             // Endless loop
    /*
    couleur(i);
    
    if(i < 10)  i++;
    else i = 0;
    
    Delay_ms(1000);
    */
    for(r = 0; r < 256; r+=16)
    {
     for(v = 0; v < 256; v+=16)
     {
      for(b = 0; b < 256; b+=16)
      {
       Delay_ms(10);
      }
     }
    }
  }
}